///home/berryj/link/bin/genMethods "-g" "-t" "UHyperGraph*" "-r" "MUHyperGraph*" "-I" "LINK/graph/UHyperGraph.h" "-y" "display_graphptr" "-m" "mark_graphptr" "-w" "free_graphptr" "-d" "graph" "-f" "__uHyperGraph_" 
#include <stk.h>
#include <LINK/stkWrapper/LINK_STk.h>

#include <LINK/graph/UHyperGraph.h>

#include <LINK/stkWrapper/Wrapper.h>
#include <LINK/stkWrapper/Register.h>

void display_graphptr(SCM, SCM, int);
void mark_graphptr(SCM);
void free_graphptr(SCM);

typedef UHyperGraph* _UHyperGraph_;

#define _UHyperGraph_DATA(x) ((UHyperGraph**) (EXTDATA(x)))
#define _UHyperGraph_IS_DATA(x) (TYPEP(x, tc_CXXwrapper) && \
		TYPEP(STk_slot_ref(x,val_scm), tc_CXXwrapper) && \
		(EXTID(STk_slot_ref(x,val_scm)) == Wrapper<UHyperGraph* >::type))
#define _UHyperGraph_ISNT_DATA(x) (!_UHyperGraph_IS_DATA(x))

#define _UHyperGraph_CXX_DATA(x) (*(UHyperGraph**) (EXTDATA(VAL(x))))
#define _UHyperGraph_CXX_IS_DATA(x) (INSTANCEP(x) && \
		TYPEP(STk_slot_ref(x,val_scm), tc_CXXwrapper) && \
		(EXTID(STk_slot_ref(x,val_scm)) == Wrapper<UHyperGraph* >::type))
#define _UHyperGraph_CXX_ISNT_DATA(x) (!_UHyperGraph_CXX_IS_DATA(x))


static SCM is_UHyperGraph_(SCM i)
{
	if (_UHyperGraph_CXX_IS_DATA(i))
		return Truth;
	return Ntruth;
}

PRIMITIVE STk_init___uHyperGraph_()
{
	Wrapper<_UHyperGraph_>::type = STk_new_CXXwrapper_id(
			Wrapper<_UHyperGraph_>::name, 
			Wrapper<MUHyperGraph* >::name,
			(void (*)(SCM x, SCM port, int mode))
			display_graphptr,
			(void (*)(SCM x))mark_graphptr,
			(void (*)(SCM x))free_graphptr);
	Tcl_InitHashTable(&Register<_UHyperGraph_>::objTable, TCL_ONE_WORD_KEYS);
	STk_add_new_cpp_primitive("UHyperGraph?", tc_subr_1,
	(PRIMITIVE (*)(...))  is_UHyperGraph_);
	return UNDEFINED;
}

void genExtra__uHyperGraph_Methods(void);

PRIMITIVE STk_init_methods___uHyperGraph_()
{
	genExtra__uHyperGraph_Methods();
	return UNDEFINED;
}
